glibmm: Gio::Emblem Class Reference

glibmm 2.66.9

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gio::Emblem Class Reference

An object for emblems. More...

`#include <giomm/emblem.h>`

Inheritance diagram for Gio::Emblem:
[legend]

## Public Member Functions
| Emblem (Emblem && src) noexcept
Emblem & | operator= (Emblem && src) noexcept
| ~Emblem () noexcept override
GEmblem * | gobj ()
| Provides access to the underlying C GObject.
const GEmblem * | gobj () const
| Provides access to the underlying C GObject.
GEmblem * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< Icon > | get_icon ()
| Gives back the icon from emblem.
Glib::RefPtr< const Icon > | get_icon () const
| Gives back the icon from emblem.
EmblemOrigin | get_origin () const
| Gets the origin of the emblem.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void * data)
void | set_data (const Quark & key, void * data, DestroyNotify notify)
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
void | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const
Public Member Functions inherited from Gio::Icon
| Icon (Icon && src) noexcept
Icon & | operator= (Icon && src) noexcept
| ~Icon () noexcept override
GIcon * | gobj ()
| Provides access to the underlying C GObject.
const GIcon * | gobj () const
| Provides access to the underlying C GObject.
guint | hash () const
| Gets a hash for an icon.
std::string | to_string () const
| Generates a textual representation of icon that can be used for serialization such as when passing icon to a different process or saving it to persistent storage.
bool | equal (const Glib::RefPtr< Icon > & other) const
Glib::VariantBase | serialize () const
| Serializes a Icon into a Variant.
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor.
| Interface (Interface && src) noexcept
Interface & | operator= (Interface && src) noexcept
| Interface (const Glib::Interface_Class & interface_class)
| Called by constructors of derived classes.
| Interface (GObject * castitem)
| Called by constructors of derived classes.
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< Emblem > | create (const Glib::RefPtr< Icon > & icon)
| Creates a new emblem for icon.
static Glib::RefPtr< Emblem > | create (const Glib::RefPtr< Icon > & icon, EmblemOrigin origin)
| Creates a new emblem for icon.
Static Public Member Functions inherited from Gio::Icon
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< Icon > | create (const std::string & str)
| Generate an Icon instance from str.
static Glib::RefPtr< Icon > | deserialize (const Glib::VariantBase & value)
| Deserializes a Icon previously serialized using g_icon_serialize().

## Protected Member Functions
| Emblem (const Glib::RefPtr< Icon > & icon)
| Creates a new emblem for icon.
| Emblem (const Glib::RefPtr< Icon > & icon, EmblemOrigin origin)
| Creates a new emblem for icon.
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)
Protected Member Functions inherited from Gio::Icon
| Icon ()
| You should derive from this class to use it.

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::Emblem > | wrap (GEmblem * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)
Related Symbols inherited from Gio::Icon
Glib::RefPtr< Gio::Icon > | wrap (GIcon * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void (*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

An object for emblems.

Emblem is an implementation of GIcon that supports having an emblem, which is an icon with additional properties. It can than be added to a EmblemedIcon.

Currently, only metainformation about the emblem's origin is supported. More may be added in the future.

Since glibmm 2.20

## Constructor & Destructor Documentation

## ◆ Emblem() [1/3]

Gio::Emblem::Emblem | ( | Emblem && | src | ) |
| noexcept

## ◆ ~Emblem()

Gio::Emblem::~Emblem | ( |  | ) |
| overridenoexcept

## ◆ Emblem() [2/3]

Gio::Emblem::Emblem | ( | const Glib::RefPtr< Icon > & | icon | ) |
| explicitprotected

Creates a new emblem for icon.

Parameters

  icon | A Gio::Icon containing the icon.

## ◆ Emblem() [3/3]

Gio::Emblem::Emblem | ( | const Glib::RefPtr< Icon > & | icon,
|  | EmblemOrigin | origin )
| explicitprotected

Creates a new emblem for icon.

Parameters

  icon | A Gio::Icon containing the icon.
  origin | An EmblemOrigin value defining the emblem's origin

## Member Function Documentation

## ◆ create() [1/2]

Glib::RefPtr< Emblem > Gio::Emblem::create | ( | const Glib::RefPtr< Icon > & | icon | ) |
| static

Creates a new emblem for icon.

Parameters

  icon | A Gio::Icon containing the icon.

## ◆ create() [2/2]

Glib::RefPtr< Emblem > Gio::Emblem::create | ( | const Glib::RefPtr< Icon > & | icon,
|  | EmblemOrigin | origin )
| static

Creates a new emblem for icon.

Parameters

  icon | A Gio::Icon containing the icon.
  origin | An EmblemOrigin value defining the emblem's origin

## ◆ get_icon() [1/2]

Glib::RefPtr< Icon > Gio::Emblem::get_icon | ( |  | ) |

Gives back the icon from emblem.

Since glibmm 2.18

Returns
  A Icon. The returned object belongs to the emblem and should not be modified or freed.

## ◆ get_icon() [2/2]

Glib::RefPtr< const Icon > Gio::Emblem::get_icon | ( |  | ) | const

Gives back the icon from emblem.

Since glibmm 2.18

Returns
  A Icon. The returned object belongs to the emblem and should not be modified or freed.

## ◆ get_origin()

EmblemOrigin Gio::Emblem::get_origin | ( |  | ) | const

Gets the origin of the emblem.

Since glibmm 2.18

Returns
  The origin of the emblem.

## ◆ get_type()

GType Gio::Emblem::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GEmblem * Gio::Emblem::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GEmblem * Gio::Emblem::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GEmblem * Gio::Emblem::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

Emblem & Gio::Emblem::operator= | ( | Emblem && | src | ) |
| noexcept

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::Emblem > wrap | ( | GEmblem * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.